<template>
  <div style="text-align: left; background-color: white; height: 100%;">

    <div class="header">Новый заказ</div>
    
    <div v-if="$store.state.tips.main" class="tip">
      Выполните авторизацию, чтобы разместить заказ

      <div @click="$store.commit('SET_TIP_STATUS', { tip: 'main', status: false })" :style="`background-image: url(${require('@/assets/img/cross.svg')})`" class="cross-icon">
      </div>
    </div>
    

    <router-link :to="{ name: 'choose-address' }">
      <div :style="`background-image: url(${require('@/assets/img/next.svg')})`" class="credential-tab">
        <span v-if="mainAddress">{{ mainAddress.name }} </span>
        <span v-else>Адрес доставки</span>
      </div>
    </router-link>
    

    <router-link :to="{ name: 'choose-shop' }">
      <div :style="`background-image: url(${require('@/assets/img/next.svg')})`" class="credential-tab">
        <span v-if="selectedShop">{{ selectedShop.name }}</span>
        <span v-else>Магазин</span>
      </div>
    </router-link>
    
    
    <router-link :to="{ name: 'choose-products' }">
      <div :style="`background-image: url(${require('@/assets/img/next.svg')})`" class="credential-tab">
        <!-- <span v-if="basketSize > 0">{{ basketSize }} товаров, стоимость {{ basketSum }}₸</span> -->
        <span v-if="$store.getters.totalPrice > 0">{{ $store.getters.totalAmount }} товаров на сумму {{ $store.getters.totalPrice }} тенге</span>
        <span v-else>Список товаров</span>
      </div>
    </router-link>

    
    <router-link :to="{ name: 'choose-card' }">
      <div :style="`background-image: url(${require('@/assets/img/next.svg')})`" class="credential-tab">
        <span v-if="mainCard">{{ mainCard.card_mask.slice(-4) }}</span>
        <span v-else>Способ оплаты</span>
      </div>
    </router-link>

    
    <div @click="mainButtonHandler($event)" class="button">
      <span style="pointer-events: none;">Подтвердить оплату</span>
    </div>

    <!-- <div class="save-in-history">Временно сохранить в историю</div> -->

    <router-view></router-view>

  </div>
</template>

<script>
import {createRipple} from "@/utils/animations.js";
import {mapGetters} from 'vuex';

import { createOrder } from '@/api/orders.js';

export default {

  created() {
    if (localStorage.getItem('token')) {
      this.$store.commit('SET_IS_AUTH', { isAuth: true });

      this.$store.dispatch('getCards');
      this.$store.dispatch('GET_ADDRESSES');

    } else {
      this.$store.commit('SET_IS_AUTH', { isAuth: false });
      this.$store.commit('TOGGLE_AUTH_MENU', { status: true });
    }
  },

  methods: {
    createRipple,

    async mainButtonHandler(event) {
      this.createRipple(event); 

      if (!this.$store.state.isAuth) {
        this.$store.commit('TOGGLE_AUTH_MENU', { status: true });
      } else {
        if (this.$store.state.basket.length && this.$store.state.addresses.length) {

          if (this.$store.getters.mainAddress && this.$store.getters.selectedShop) {
            
            const data = {
              store_id: this.$store.getters.selectedShop.id,
              ship_name: this.$store.getters.mainAddress.name,
              ship_description: this.$store.getters.mainAddress.description,
              ship_latitude: this.$store.getters.mainAddress.latitude,
              ship_longitude: this.$store.getters.mainAddress.longitude
            };

            let result = await createOrder(data);

            window.alert('Заказ создан', JSON.stringify(result));
          }
          
        }
        
      }
    }
  },
  computed: {
    ...mapGetters(['mainAddress', 'mainCard', 'selectedShop']),
  }
}
</script>

<style>
  .header {
    text-align: center; 
    padding: 57px 10px 25px 10px;
    background-color: #f5f5f5;
  }

  .button {
    position: relative;
    overflow: hidden;
    transition: background 400ms;
    border-radius: 5px;
    padding: 20px 20px; 
    text-align: center; 
    background-color: #f9fafb; 
    cursor: pointer;
    margin-top: 20px;
    margin-right: 10px;
    margin-left: 10px;
  }

  .credential-tab {
    position: relative; 
    border-bottom: 1px solid #f5eaea; 
    padding: 20px 20px;
    background-repeat: no-repeat;
    background-position: top 22px right 30px;
  }

  /* .credential-tab::after {
    content: '';
    position: absolute;
    right: 28px;
    width: 17px;
    height: 17px;
    background-color: #4C95B4;
    border-radius: 50%;
  } */

  .tip {
    position: relative; 
    background-color: #83acea;
    color: white; 
    border-bottom: 1px solid #f5eaea; 
    padding: 20px 80px 20px 20px;
  }

  .cross-icon {
    position: absolute;
    top: calc(50% - 20px);
    right: 15px;
    width: 40px;
    height: 40px;
    background-repeat: no-repeat;
    background-position: center;
  }

  .save-in-history {
    text-align: center;
    color: red;
    margin-top: 5px;
    padding: 20px;
    cursor: pointer;
  }

  span.ripple {
    position: absolute; /* The absolute position we mentioned earlier */
    border-radius: 50%;
    transform: scale(0);
    animation: ripple 600ms linear;
    background-color: rgba(255, 255, 255, 0.7);
  }

  @keyframes ripple {
    to {
      transform: scale(4);
      opacity: 0;
    }
  }
</style>